
# SOURCE: http://stackoverflow.com/questions/1456373/two-way-reverse-map

class TwoWayDict(dict):
    def __setitem__(self, key, value):
        # Remove any previous connections with these values
        if key in self:
            del self[key]
        if value in self:
            del self[value]
        dict.__setitem__(self, key, value)
        dict.__setitem__(self, value, key)

    def __delitem__(self, key):
        dict.__delitem__(self, self[key])
        dict.__delitem__(self, key)

    def __len__(self):
        """Returns the number of connections"""
        return dict.__len__(self) // 2

def convert_to_bidict(d):
    newD = TwoWayDict()
    for k,v in d.items(): # PYTHON 3!
        newD[k] = v
    return newD